/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.ui.editor;

import static java.util.Arrays.asList;
import static org.fortiss.af3.allocation.model.AF3AllocationPackage.Literals.ALLOCATION_TABLE__SOURCE_VIEW;
import static org.fortiss.af3.allocation.model.AF3AllocationPackage.Literals.ALLOCATION_TABLE__TARGET_VIEW;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.swt.widgets.Composite;
import org.fortiss.af3.allocation.ui.editor.ModelListenerEditorBase;
import org.fortiss.af3.platform.model.PlatformArchitecture;
import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * Editor that embeds an {@link InterferenceLatencyTableEditor} within a
 * {@link PlatformArchitecture} editor.
 * 
 * @author diewald
 */
public class InterferenceLatencyEditor extends ModelListenerEditorBase<PlatformArchitecture> {

	/** References the underlying editor for the parameter table. */
	private InterferenceLatencyTableEditor iltEditor;

	/** Constructor. */
	public InterferenceLatencyEditor() {
		super(asList(ALLOCATION_TABLE__SOURCE_VIEW, ALLOCATION_TABLE__TARGET_VIEW));
	}

	/** {@inheritDoc} */
	@Override
	public void createPartControl(Composite parent) {
		super.createPartControl(parent);

		iltEditor = new InterferenceLatencyTableEditor(getEditedObject());
		iltEditor.createPartControl(parent);
	}

	/** {@inheritDoc} */
	@Override
	protected boolean isEditedEntity(Object object) {
		// TODO Auto-generated method stub
		return false;
	}

	/** {@inheritDoc} */
	@Override
	protected void addEntity(IModelElement entity) {
		// TODO Auto-generated method stub
	}

	/** {@inheritDoc} */
	@Override
	protected void removeEntity(IModelElement entity) {
		// TODO Auto-generated method stub
	}

	/** {@inheritDoc} */
	@Override
	protected void renameEntity(IModelElement entity) {
		// TODO Auto-generated method stub
	}

	/** {@inheritDoc} */
	@Override
	protected void valueSet(EObject eObject) {
		// TODO Auto-generated method stub
	}

	/** {@inheritDoc} */
	@Override
	protected boolean isEditedModel(Object object) {
		// Not used.
		return false;
	}

	/** {@inheritDoc} */
	@Override
	protected void comboViewerOpened(ComboViewer viewer) {
		// Not used
	}
}
