/*-------------------------------------------------------------------------+
| Copyright 2017 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.ui.editor;

import org.eclipse.ui.IEditorPart;
import org.fortiss.af3.platform.model.PlatformArchitecture;
import org.fortiss.af3.task.model.TaskArchitecture;
import org.fortiss.tooling.kernel.ui.extension.base.ModelEditorBindingBase;

/**
 * Editor for user-provided temporal properties of {@link TaskArchitecture}s (WCETs, periods).
 * 
 * @author diewald
 */
public class InterferenceLatencyEditorBinding extends ModelEditorBindingBase<PlatformArchitecture> {

	/** {@inheritDoc} */
	@Override
	public Class<? extends IEditorPart> getEditorClass() {
		return InterferenceLatencyEditor.class;
	}

	/** {@inheritDoc} */
	@Override
	public String getLabel() {
		return "Interferences";
	}

	/** {@inheritDoc} */
	@Override
	public int getPriority() {
		return -1;
	}
}
