/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.InjectorProvider;
import org.opt4j.core.start.Opt4JModule;

import com.google.inject.Inject;
import com.google.inject.Injector;
import com.google.inject.Provider;
import com.google.inject.Singleton;

/**
 * Provides the {@link Opt4JDseTask} wrapper that allows accessing the {@link Inject} used in the
 * Opt4J framework.
 * 
 * @author diewald
 */
@Singleton
public class Opt4JDseTaskProvider extends InjectorProvider
		implements Provider<Opt4JDseTaskProvider> {

	/** {@link Opt4JDseTask} instance that holds the injector used for {@link Opt4JModule}s. */
	private Opt4JDseTask opt4JDseTask;

	/** Sets the {@link Opt4JDseTask} used to query the Opt4J {@link Injector}. */
	public void setInjector(Opt4JDseTask opt4JTask) {
		this.opt4JDseTask = opt4JTask;
	}

	/** {@inheritDoc} */
	@Override
	public Injector getInjector() {
		return opt4JDseTask.get();
	}

	/** {@inheritDoc} */
	@Override
	public Opt4JDseTaskProvider get() {
		return this;
	}
}
