/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.create;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.InjectorProvider;

import com.google.inject.Injector;
import com.google.inject.Provides;
import com.google.inject.Singleton;

/**
 * Holds the {@link Injector} responsible for the Create phase.
 * 
 * @author diewald
 */
public class CreateInjectorProvider extends InjectorProvider {

	/** Provides the {@link CreateInjectorProvider} singleton. */
	@Provides
	@Singleton
	public CreateInjectorProvider get() {
		return new CreateInjectorProvider();
	}
}
