/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.phenotype;

import org.opt4j.core.genotype.CompositeGenotype;

/**
 * Interface for {@link Phenotype}s generated by decoders which operate on {@link CompositeGenotype}
 * s.
 * 
 * @author diewald
 */
public interface Phenotype {

	/** Marks a phenotype as being processed by sub-decoders. */
	void setSubDecoding(boolean isSubDecoding);

	/** Returns whether the {@link Phenotype} is currently processed by sub-decoders. */
	boolean isSubDecoding();
}
