/*-------------------------------------------------------------------------+
| Copyright 2015 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.partition.variable;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.create.Creates;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.TaskGraphEncoding;
import org.fortiss.af3.exploration.alg.feature.taskmapping.variable.TaskMappingCreatorBase;
import org.fortiss.af3.exploration.alg.feature.taskmapping.variable.TaskMappingEntry;
import org.opt4j.core.problem.Creator;

import com.google.inject.Provides;

/**
 * {@link Creator} for an {@link TaskPartitionMappingEncoding}, which allocates tasks to partitions.
 * 
 * @author diewald
 */
public class TaskPartitionMappingCreator extends
		TaskMappingCreatorBase<Partition, TaskMappingEntry<ITaskAdapter, Partition>, TaskPartitionMappingEncoding> {

	/** Creates an {@link TaskGraphEncoding} initialized with random allocations. */
	@Provides
	@Creates
	public TaskPartitionMappingEncoding create(PartitionMappingEncoding partEnc,
			TaskGraphEncoding tgEnc) {
		return new TaskPartitionMappingEncoding(partEnc.getRequesters(), tgEnc, constraints.get(),
				true);
	}

	/** {@inheritDoc} */
	@Override
	public TaskPartitionMappingEncoding create() {
		return null;
	}
}
