/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.scheduling.problem.graph;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.decode.Decodes;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.taskgraph.AcyclicTaskGraph;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.AcyclicTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.module.DecoderModule;
import org.opt4j.core.Genotype;

import com.google.inject.Provides;

/**
 * {@link DecoderModule} that processes input {@link AcyclicTaskGraph}s to turn them into an acyclic
 * graph of schedulable tasks.
 * 
 * @author diewald
 */
public class ScheduleTaskGraphDecoder extends DecoderModule<ScheduleTaskGraphEncoding> {

	/** See {@link ScheduleTaskGraphDecoder}. */
	@Provides
	@Decodes
	public ScheduleTaskGraphEncoding decode(AcyclicTaskGraphEncoding atgEnc) {
		return new ScheduleTaskGraphEncoding(atgEnc);
	}

	/** {@inheritDoc} */
	@Override
	public ScheduleTaskGraphEncoding decode(Genotype genotype) {
		// TODO Auto-generated method stub
		return null;
	}
}
