/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.scheduling.scheduler;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.model.ExplorationTarget;
import org.fortiss.af3.exploration.moea.model.constraints.DeadlineConstraint;

/**
 * Base class for schedulers.
 * 
 * @author barner
 */
public class SchedulerBase {
	/** Precision for double */
	protected final static int DOUBLE_PRECISION = 10;

	/** Contains the References to the {@link ExplorationTarget}s related to timing. */
	protected Collection<DeadlineConstraint> deadlines;

	/** Contains the reference deployable component -> deadline value. */
	protected Map<ITaskAdapter, DeadlineConstraint> componentDeadlineSourceMap;

	/** Contains the reference deadline -> target component. */
	protected Map<DeadlineConstraint, ITaskAdapter> deadlineTargetComponent;

	/** Constructs a scheduler for a given input model. */
	// TODO: Readd deadline constraints.
	public SchedulerBase() {
		// this.deadlines =
		// expSpec.getTargets().stream().filter(t -> (t instanceof DeadlineConstraint))
		// .map(DeadlineConstraint.class::cast).collect(Collectors.toList());

		componentDeadlineSourceMap = new HashMap<ITaskAdapter, DeadlineConstraint>();
		deadlineTargetComponent = new HashMap<DeadlineConstraint, ITaskAdapter>();

		// createComponentDeadlineMap();
	}

	/**
	 * Creates two maps that
	 * <li>relate a {@link ITaskAdapter} which is defined as the "source" of a
	 * deadline to its {@link DeadlineConstraint} and
	 * <li>a map that relates
	 * {@link DeadlineConstraint}s with its "target" {@link ITaskAdapter}s.
	 */
	// private void createComponentDeadlineMap() {
	// if(deadlines == null) {
	// return;
	// }
	//
	// for(DeadlineConstraint currentDeadline : deadlines) {
	// for(ITaskAdapter deployableComponent : schedule) {
	// if(deployableComponent.getObject() == currentDeadline.getStartComponent()) {
	// componentDeadlineSourceMap.put(deployableComponent, currentDeadline);
	// } else if(deployableComponent.getObject() == currentDeadline.getEndComponent()) {
	// deadlineTargetComponent.put(currentDeadline, deployableComponent);
	// }
	// }
	// }
	// }
}
