/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.taskinstantiation.problem;

import java.util.Collection;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.taskgraph.AcyclicTaskGraph;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.taskgraph.ITaskGraph;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.TaskGraphEncoding;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.TaskGraphEncodingBase;

/**
 * {@link TaskGraphEncodingBase} for {@link AcyclicTaskGraph}s that contain <i>concrete</i> tasks
 * exclusively. The contained {@link ITaskGraph}s are directed and acyclic and hence a suitable
 * input for schedulers.
 * 
 * @author diewald
 */
public class InstantiatedAcyclicTaskGraphEncoding
		extends InstantiatedTaskGraphEncodingBase<AcyclicTaskGraph> {
	/** Constructor. */
	public InstantiatedAcyclicTaskGraphEncoding(Collection<AcyclicTaskGraph> collection,
			Double hyperPeriod) {
		super(collection, hyperPeriod);
	}

	/** Copy Constructor. See {@link TaskGraphEncoding#TaskGraphEncoding(TaskGraphEncoding)}. */
	public InstantiatedAcyclicTaskGraphEncoding(InstantiatedAcyclicTaskGraphEncoding encoding) {
		super(encoding);
	}
}
