/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.taskmapping.variable;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IExecutionUnitAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;

/**
 * A mapping entry of an {@link ITaskAdapter} to a physical {@link IExecutionUnitAdapter}.
 * 
 * @author diewald
 */
public class TaskExUMappingEntry
		extends TaskMappingEntry<ITaskAdapter, IExecutionUnitAdapter> {

	/** Constructor. */
	public TaskExUMappingEntry(ITaskAdapter source, IExecutionUnitAdapter target) {
		super(source, target);
	}

	/** Copy constructor. */
	public TaskExUMappingEntry(TaskExUMappingEntry mapping) {
		super(mapping);
	}
}
