/*-------------------------------------------------------------------------+
| Copyright 2014 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.taskmapping.variable.operator;

import org.fortiss.af3.exploration.alg.feature.partition.variable.TaskPartitionMappingEncoding;
import org.fortiss.af3.exploration.alg.feature.taskmapping.variable.TaskExUMappingEncoding;
import org.fortiss.af3.exploration.alg.module.common.operator.crossover.mapping.CrossoverRandManyAllocation;
import org.opt4j.operators.crossover.BasicCrossoverModule;
import org.opt4j.operators.crossover.Crossover;

/**
 * Crossover module selecting the {@link CrossoverRandManyAllocation} operator to be applied on
 * {@link TaskPartitionMappingEncoding}s.
 * 
 * @author diewald
 */
public class CrossoverTaskExUMappingModule extends BasicCrossoverModule {

	/** {@inheritDoc} */
	@SuppressWarnings("unchecked")
	@Override
	public void config() {
		super.config();

		addOperator(TaskExUMappingEncoding.class,
				(Class<? extends Crossover<?>>)CrossoverRandManyAllocation.class);
	}
}
