/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.module.common.input;

import static java.util.Collections.emptySet;

import java.util.Set;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.alg.module.InputModule;
import org.fortiss.af3.exploration.alg.module.InputProvider;

import com.google.inject.Provides;
import com.google.inject.Singleton;

/**
 * Creates the D3SE-internal representation of safety functions.
 * 
 * @author diewald
 */
// TODO(AD): Migrate the code from the SystemModelAdapter.
public class SafetyFunctionModule extends InputModule<Set<ISafetyFunctionAdapter>> {

	/** Provides the {@link ITaskAdapter}s of the task architecture. */
	@Provides
	@InputProvider
	@Singleton
	public Set<ISafetyFunctionAdapter> getTasks() {
		return emptySet();
	}
}
