/*-------------------------------------------------------------------------+
| Copyright 2019 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.moea.model.constraints.impl;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IRequestAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IResourceAdapter;
import org.fortiss.af3.exploration.moea.model.constraints.InternalConstraint;

/**
 * Static implementations of {@link InternalConstraint}.
 * 
 * @author diewald
 */
public class InternalConstraintStaticImpl {

	/** Static implementation of {@link InternalConstraint#getSetOf(Object)}. */
	/* package */ @SuppressWarnings("unchecked")
	static <S> EList<S> getSetOf(InternalConstraint<?> internalConstraint, S element) {
		if(element instanceof IRequestAdapter &&
				internalConstraint.getSources().contains(element)) {
			return (EList<S>)internalConstraint.getSources();
		} else if(element instanceof IResourceAdapter &&
				internalConstraint.getTargets().contains(element)) {
			return (EList<S>)internalConstraint.getTargets();
		}
		return new BasicEList<>();
	}
}
